<?php
/******************************************************************
*			       Runfile for your Miner					  	  *
*					A: Sven Goessling							  *
*					W: Miner-Control.de							  *
*						V: 1.0.0								  *
******************************************************************/
//Config File
include_once(__DIR__."/config.php");
	if (!isset($TransactionHash) || $TransactionHash == "" || !isset($MinerToken) || $MinerToken == "") {
		echo 'No Config Infos found.'.PHP_EOL;
		exit;
	} else {
		include_once(__DIR__."/class.miner.php");
		$security_decode = 'sgsrREWG41Dd4gjr885ffqc1!gg4FDF44';
		echo '- Collect Miner Infos:';
		$miner = new LocalMiner('127.0.0.1', 4028);
		
		$protocol = 'https://';
		$Miner_Control = 'miner-control.de';
		//$Miner_Control = '192.168.116.129'; //TEST SERVER
		$postminer = '/miner.php';
		
		//Claim Miner Infos
		$send_miner_infos = array();
		$send_miner_infos['TRANSACTIONHASH'] 	= $TransactionHash;
		$send_miner_infos['TOKEN'] 				= $MinerToken;
		$send_miner_infos['VERSION'] 			= $miner->version();
		$send_miner_infos['APIVERSION'] 		= $miner->apiversion();
		$send_miner_infos['UPTIME'] 			= $miner->uptime();
		$send_miner_infos['SUMMERY'] 			= $miner->allinfos();
		$send_miner_infos['POOLS'] 				= $miner->pools();
		for ($i = 0; $i < sizeof($send_miner_infos['POOLS']); $i++) {
			$send_miner_infos['POOLSTATS'][$i] 			= $miner->stats($i);
		}
		$send_miner_infos['HASHRATE'] 			= $miner->hashrate();
		$send_miner_infos['DEVICES'] 			= $miner->devices();
		$send_miner_infos['SHARES'] 			= $miner->shares();
		
		$send = json_encode($send_miner_infos);
		$send = base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, md5($security_decode), $send, MCRYPT_MODE_CBC, md5(md5($security_decode))));
		$fields = array(
						'transactioncode' 	=> urlencode($send_miner_infos['TRANSACTIONHASH']),
						'minertoken' 		=> urlencode($send_miner_infos['TOKEN']),
						'miner_infos' 		=> urlencode($send)
						);
		$fields_string = '';
		foreach($fields as $key=>$value) { 
			$fields_string .= $key.'='.$value.'&'; 
		}
		rtrim($fields_string, '&');
		
		//open connection
		$ch = curl_init();

		//set the url, number of POST vars, POST data
		curl_setopt($ch,CURLOPT_URL, $protocol.$Miner_Control.$postminer);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch,CURLOPT_POST, count($fields));
		curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, (($Miner_Control == '192.168.116.129')?0:1));

		//execute post
		$result = curl_exec($ch);
		$httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		//close connection
		curl_close($ch);
		
		if($httpCode == 200) {
			echo 'OK'.PHP_EOL;
			$json = json_decode($result, true);	
		} else {
			echo ' 404 ERROR. NOT FOUND'.PHP_EOL;
			exit;
		}
		
		
		//print_r($result);
		//print_r($json);
		
		if (is_array($json)) {
			echo '- Neue Befehle erhalten:';
			//Commands
			//$miner->restart();
			//$miner->switchpool($pool_id);
		}
		
		
	}
?>